#include <stdio.h>

/* strcat2: concatenate t to end of s; s must be big enough  */
void strcat2(char s[], char t[]);

/* getbits: get n bits from position p  */
unsigned getbits(unsigned x, int p, int n );

/* bitcount: count 1 bits in x  */
int bitcount(unsigned x);


int main()
{
    char mystring[] = "this is string one";
    char mystring2[] = "my string two";
    char result[200] = "";

    int x, y;


    strcat2( result, mystring );
    strcat2( result, mystring2 );

    printf ("%s\n", result);

    x = ~077;
    printf ("%d\n", x );

    x = ~0;
    printf ("%d\n", x );

    x = 255;
    y = getbits(x, 4, 3);

    printf ("getbits=%d\n", y);

    y = bitcount( x );
    printf ("bitcounts=%d\n", y);

}

unsigned getbits(unsigned x, int p, int n )
{
    return (x >> (p+1-n)) & ~(~0 << n);
}


/* strcat2: concatenate t to end of s; s must be big enough  */
void strcat2(char s[], char t[])
{
    int i, j;
    i = j = 0;

    while (s[i] != '\0')  /* find end of s  */
        i++;
    while ((s[i++] = t[j++]) != '\0')  /* copy t  */
        ;

}


/* bitcount: count 1 bits in x  */
int bitcount(unsigned x)
{
    /* declaring the argument x to be an unsigned ensures that when it is right shifted,
     vacated bits will be filled with zeros, not sign bits, regardless of the machine the program is run on. */

    int b;
    for (b = 0; x!=0; x >>= 1)
        if (x & 01)
            b++;
    return b;
}
